//RahmenAttributeKopieren_403d.js
// 17.09.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Die Eigenschaften eines Rahmens auf einen zweiten bertragen

// Abmessungen und/oder die Position des Musterrahmens bernehmen: 
// wenn anstelle einer 'true'-Zeile eine 'false'-Zeile aktiviert ist, 
// dann werden die entsprechenden Werte nicht bernommen.
// Zum Deaktivieren am Anfang der Zeile zwei Bruchstriche eingeben, 
// zum Aktivieren am Anfang der Zeile die beiden Bruchstriche entfernen.

// Anmerkung: Wenn zwei Rahmen im selben Dokument ausgewhlt sind, 
// dann wird der Wert von 'copyPos' ignoriert
var copySize = true;    // die Rahmengrsse bernehmen
//var copySize = false; // die Rahmengrsse nicht ndern
var copyPos  = true;    // die Position des Musterrahmens bernehmen
//var copyPos  = false; // Zielrahmen nicht verschieben

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Funktion aufrufen, welche die geffneten Dokumente auflistet
docRef = getDocRef();
nRefs  = docRef.length;
if (nRefs == 1) {
	docOne = docRef[0];
	docTwo = docRef[0];
	sameDoc = true;
	a = 0;
	b = 1;
}
else {
	docOne = docRef[0];
	docTwo = docRef[1];
	if (docOne == docTwo) {
		alert ("Die Namen der beiden Dokumente drfen nicht identisch sein.", "Stop");
		exit();
	}
	sameDoc = false;
	a = 0;
	b = 0;
}

// prfen, welche Variablen initialisiert sind
try {
	testVal = copySize;
}
catch (e) {
	alert ("Die Variable \"copySize\" aktivieren.", "Stop");
	exit();
}
if (!sameDoc) {
	try {
		testVal = copyPos;
	}
	catch (e) {
		alert ("Die Variable \"copyPos\" aktivieren.", "Stop");
		exit();
	}
}
else {
	copyPos = false;
}

// den Linealursprung speichern und auf "Druckbogen" setzen (falls notwendig)
ro0 = app.documents.itemByName(docOne).viewPreferences.rulerOrigin;
if (!sameDoc) {
	ro1 = app.documents.itemByName(docTwo).viewPreferences.rulerOrigin;
}
if (ro0 != 1380143983) {
	app.documents.itemByName(docOne).viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
}
if (!sameDoc) {
	if (ro1 != 1380143983) {
		app.documents.itemByName(docTwo).viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
	}
}

// die Funktion aufrufen, welche die Auswahl prft
checkSel();

// wenn nur ein Dokument, versuchen, den Musterrahmen zu erraten
if (sameDoc) {
	frameA = app.documents.itemByName(docOne).selection[a];
	frameB = app.documents.itemByName(docOne).selection[b];
	var aFillColor = frameA.fillColor.name;
	var bFillColor = frameB.fillColor.name;
	if (aFillColor == "None") {
		if (bFillColor != "None") {
			app.select(frameA, SelectionOptions.REMOVE_FROM);
			masterSelected = askUser();
			app.select(frameA, SelectionOptions.ADD_TO);
		}
		else {
			app.select(frameB, SelectionOptions.REMOVE_FROM);
			masterSelected = askUser();
			app.select(frameB, SelectionOptions.ADD_TO);
		}
	}
	else {
		app.select(frameB, SelectionOptions.REMOVE_FROM);
		masterSelected = askUser();
		app.select(frameB, SelectionOptions.ADD_TO);
	}
	if (masterSelected) {
		a = 1;
		b = 0;
	}
}

// die Abmessungen holen (wenn Grsse oder Position gefragt ist)
if (copySize || copyPos) {
	getBounds();
}

// je nach gewhlter Einstellung die entsprechenden Funktionen aufrufen
if (copySize && copyPos) {
	setBounds();
}
else if (copySize && !copyPos) {
	setSize();
}
else if (!copySize && copyPos) {
	setPos();
}

// den Handler aufrufen, welcher die Attribute zuweist
setProps();

// den Linealursprung zurcksetzen
resetAsBefore();


///////////////////////////////////////////////////////////////////////////////
// die Funktionen
///////////////////////////////////////////////////////////////////////////////

// die Liste der geffneten Dokumente
function getDocRef() {
	docRef = new Array ();
	nDocs = app.documents.length;
	if (nDocs !=0) {
		for (var i=0; i<app.documents.length; i++) {
			docRef.push(app.documents[i].name);
		}
	}
	else {
		alert ("Es ist kein Dokument offen.", "Achtung");
		exit();
	}
	return docRef;
}

// die Auswahl prfen
function checkSel() {
	try {
		var testType1 = app.documents.itemByName(docOne).selection[a].constructor.name;
		if (testType1 != "Rectangle" && testType1 != "TextFrame") {
			if (testType1 == "Group") {
				resetAsBefore();
				alert ("Dokument \"" + docOne + "\":" + "\n\nKeine Gruppen auswhlen.", "Stop");
				exit();
			}
			else {
				resetAsBefore();
				alert ("Dokument \"" + docOne + "\":" + "\n\nNur rechteckige Rahmen auswhlen.", "Stop");
				exit();
			}
		}
	}
	catch (e) {
		resetAsBefore();
		alert ("Dokument \"" + docOne + "\":" + "\n\n" + "es ist kein Rahmen ausgewhlt.", "Achtung");
		exit();
	}
	try {
		var testType2 = app.documents.itemByName(docTwo).selection[b].constructor.name;
		if (testType2 != "Rectangle" && testType2 != "TextFrame") {
			if (testType2 == "Group") {
				resetAsBefore();
				alert ("Dokument \"" + docTwo + "\":" + "\n\nKeine Gruppen auswhlen.", "Stop");
				exit();
			}
			else {
				resetAsBefore();
				alert ("Dokument \"" + docTwo + "\":" + "\n\nNur rechteckige Rahmen auswhlen.", "Stop");
				exit();
			}
		}
	}
	catch (e) {
		resetAsBefore();
		if (sameDoc) {
			alert ("Dokument \"" + docTwo + "\":" + "\n\n" + "es ist kein zweiter Rahmen ausgewhlt.", "Achtung");
		}
		else {
			alert ("Dokument \"" + docTwo + "\":" + "\n\n" + "es ist kein Rahmen ausgewhlt.", "Achtung");
		}
		exit();
	}
}

// die Abmessungen speichern
function getBounds() {
	try {
		boxRotation1 = app.documents.itemByName(docOne).selection[a].rotationAngle;
		if (boxRotation1 != 0) {
			app.documents.itemByName(docOne).selection[a].rotationAngle = 0;
		}
		boxBounds1 = app.documents.itemByName(docOne).selection[a].geometricBounds;
		if (boxRotation1 != 0) {
			app.documents.itemByName(docOne).selection[a].rotationAngle = boxRotation1;
		}
	}
	catch (e) {
	}
	try {
		boxBounds2 = app.documents.itemByName(docTwo).selection[b].geometricBounds;
		boxRotation2 = app.documents.itemByName(docTwo).selection[b].rotationAngle;
	}
	catch (e) {
	}
}

// der Dialog, zum Beantworten, ob der Musterrahmen ausgewhlt blieb
function askUser() {
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"Ist der Muster-Rahmen noch ausgewhlt?"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Was trifft zu?"});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var folButtons = radiobuttonGroups.add();
				with (folButtons) {
					radiobuttonControls.add({staticLabel:"der Muster-Rahmen ist ausgewhlt", checkedState:true});
					radiobuttonControls.add({staticLabel:"der Muster-Rahmen ist nicht mehr ausgewhlt", checkedState:false});
				}
			}
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		var folBtn = folButtons.selectedButton;
		if (folBtn == 0) {
			dlogResult = true;
		}
		else if (folBtn == 1) {
			dlogResult = false;
		}
		aDialog.destroy();
		return dlogResult;
	}
	else {
		resetAsBefore();
		aDialog.destroy();
		exit();
	}
}

// Abmessungen und Position zuweisen
function setBounds() {
	try {
		if (boxRotation1 == 0 && boxRotation2 != 0 || boxRotation1 != 0 && boxRotation2 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = 0;
		}
		app.documents.itemByName(docTwo).selection[b].geometricBounds = boxBounds1;
	}
	catch (e){
	}
	try {
		if (boxRotation1 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = boxRotation1;
		}
	}
	catch (e){
	}
}

// nur die Abmessungen zuweisen
function setSize() {
	try {
		if (boxRotation2 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = 0;
		}
		var gB = app.documents.itemByName(docTwo).selection[b].geometricBounds;
		var y1 = gB[0];
		var x1 = gB[1];
		var fH = boxBounds1[2]-boxBounds1[0];
		var fW = boxBounds1[3]-boxBounds1[1];
		app.documents.itemByName(docTwo).selection[b].geometricBounds = [y1, x1, y1+fH, x1+fW];
	}
	catch (e){
	}
	try {
		if (boxRotation1 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = boxRotation1;
		}
	}
	catch (e){
	}
}

// nur an die Position verschieben (Abmessungen nicht verndern)
function setPos() {
	try {
		if (boxRotation2 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = 0;
		}
		var gB = app.documents.itemByName(docTwo).selection[b].geometricBounds;
		var y1 = boxBounds1[0];
		var x1 = boxBounds1[1];
		app.documents.itemByName(docTwo).selection[b].move([x1, y1], undefined);
	}
	catch (e){
	}
	try {
		if (boxRotation1 != 0) {
			app.documents.itemByName(docTwo).selection[b].rotationAngle = boxRotation1;
		}
	}
	catch (e){
	}
}

// die Attribute bertragen
function setProps() {
	curProps = app.documents.itemByName(docOne).selection[a].properties;
	targetFrame = app.documents.itemByName(docTwo).selection[b];
	var boxWrap = curProps.textWrapPreferences.textWrapOffset;
	var fic = curProps.fillColor.name;
	var fit = curProps.fillTint;
	var opa = curProps.opacity;
	var frw = curProps.strokeWeight;
	var fry = curProps.strokeType;
	var frc = curProps.strokeColor.name;
	var frt = curProps.strokeTint;
	var fra = curProps.strokeAlignment;
	var cef = curProps.cornerEffect;
	var crd = curProps.cornerRadius;
	if (fic != "None") {
		testColor(fic);
	}
	if (frc != "None") {
		testColor(frc);
	}
	targetFrame.properties = {strokeAlignment:fra, fillColor:fic, fillTint:fit, opacity:opa, 
		strokeWeight:frw, strokeType:fry, strokeColor:frc, strokeTint:frt, cornerEffect:cef, cornerRadius:crd};
	if (boxWrap != 1852796517) {
		var wrapType = curProps.textWrapPreferences.textWrapType;
		targetFrame.textWrapPreferences.textWrapType = wrapType;
		targetFrame.textWrapPreferences.textWrapOffset = boxWrap;
	}
	var shm = curProps.transparencySettings.dropShadowSettings;
	if (shm.mode != 1852796517) {
		var shc = shm.effectColor.name;
		testColor(shc);
		var san = shm.angle;
		var sbm = shm.blendMode;
		var sdi = shm.distance;
		var she = shm.honorOtherEffects;
		var sko = shm.knockedOut;
		var shn = shm.noise;
		var sho = shm.opacity;
		var sbr = shm.size;
		var sgl = shm.useGlobalLight;
		var shs = shm.spread;
		var sxo = shm.xOffset;
		var syo = shm.yOffset;
		targetFrame.transparencySettings.dropShadowSettings.properties = 
		{mode:2020623440, angle:san, blendMode:sbm, distance:sdi, effectColor:shc, honorOtherEffects:she, 
		knockedOut:sko, noise:shn, opacity:sho, size:sbr, spread:shs, useGlobalLight:sgl, xOffset:sxo, yOffset:syo};
	}
	else {
		targetFrame.transparencySettings.dropShadowSettings.mode = 1852796517;
	}
	if (targetFrame.constructor.name == "TextFrame") {
		try {
			var txtFrPrefs = curProps.textFramePreferences.properties;
			targetFrame.textFramePreferences.properties = txtFrPrefs;
		}
		catch (e) {
		}
	}
}

// die Funktion, welche das Vorhandensein der Farben prft
// wenn eine nicht existiert, wird sie erzeugt
function testColor(curName) {
	if (!sameDoc) {
		try {
			colorProps2 = app.documents.itemByName(docTwo).colors.item(curName).properties;
		}
		catch (e) {
			try {
				colorProps1 = app.documents.itemByName(docOne).colors.item(curName).properties;
				var newColor = app.documents.itemByName(docTwo).colors.add({name:curName});
				newColor.properties = colorProps1;
				newColor.name = curName;
			}
			catch (e) {
			}
		}
	}
}

// den Linealursprung zurcksetzen (falls notwendig)
function resetAsBefore() {
	if (ro0 != 1380143983) {
		ro0 = app.documents.itemByName(docOne).viewPreferences.rulerOrigin = ro0;
	}
	if (!sameDoc) {
		if (ro1 != 1380143983) {
			ro1 = app.documents.itemByName(docTwo).viewPreferences.rulerOrigin = ro1;
		}
	}
}